PSmartPtr< T > Class Template Reference

This template class creates a type safe version of PSmartPointer. More...

`#include <smartptr.h>`

Inheritance diagram for PSmartPtr< T >:

## Public Member Functions

| PSmartPtr (T *ptr=NULL)
| Constructor. More...
T * | operator-> () const
| Access to the members of the smart object in the smart pointer. More...
T & | operator* () const
| Access to the dereferenced smart object in the smart pointer. More...
| operator T* () const
| Access to the value of the smart pointer. More...
Public Member Functions inherited from PSmartPointer
| PSmartPointer (PSmartObject *obj=NULL)
| Create a new smart pointer instance and have it point to the specified `PSmartObject` instance. More...
| PSmartPointer (const PSmartPointer &ptr)
| Create a new smart pointer and point it at the data pointed to by the `ptr` parameter. More...
virtual | ~PSmartPointer ()
| Destroy the smart pointer and decrement the reference count on the object being pointed to. More...
PSmartPointer & | operator= (const PSmartPointer &ptr)
| Assign this pointer to the value specified in the `ptr` parameter. More...
virtual Comparison | Compare (const PObject &obj) const
| Determine the relative rank of the pointers. More...
PBoolean | IsNULL () const
| Determine if the smart pointer has been set to point to an actual object instance. More...
PSmartObject * | GetObject () const
| Get the current value if the internal smart object pointer. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PSmartPointer
PSmartObject * | object
| Object the smart pointer points to. More...

## Detailed Description

### template<class T>
class PSmartPtr< T >

This template class creates a type safe version of PSmartPointer.

## Constructor & Destructor Documentation

## PSmartPtr()

template<class T >

PSmartPtr< T >::PSmartPtr | ( | T * | ptr = `NULL` | ) |

inline

Constructor.

## Member Function Documentation

## operator T*()

template<class T >

PSmartPtr< T >::operator T* | ( |  | ) | const

inline

Access to the value of the smart pointer.

## operator*()

template<class T >

T& PSmartPtr< T >::operator* | ( |  | ) | const

inline

Access to the dereferenced smart object in the smart pointer.

References PAssertNULL.

## operator->()

template<class T >

T* PSmartPtr< T >::operator-> | ( |  | ) | const

inline

Access to the members of the smart object in the smart pointer.

References PAssertNULL.

The documentation for this class was generated from the following file:

- smartptr.h